/*
 * $Id: RCBrain.java,v 1.38 2002/07/09 21:42:32 stork Exp $
 *
 * $Log: RCBrain.java,v $
 * Revision 1.38  2002/07/09 21:42:32  stork
 * update doukumentation
 *
 * Revision 1.37  2002/07/07 23:10:32  transier
 * minimal final changes of parameters
 *
 * Revision 1.36  2002/07/07 22:42:22  transier
 * final changes
 *
 * Revision 1.35  2002/07/07 19:26:18  transier
 * getAngleToGoal removed
 *
 * Revision 1.34  2002/07/07 18:13:31  transier
 * improved getPassPartner function
 *
 * Revision 1.33  2002/07/07 15:20:05  transier
 * changed some parameters, private -> protected
 *
 * Revision 1.32  2002/07/07 14:10:39  ritter
 * changed some private functions to public
 *
 * Revision 1.31  2002/07/06 11:08:49  transier
 * remove NewData support from dash command
 * changed some paramteres
 *
 * Revision 1.30  2002/07/05 09:32:57  ritter
 * variation of some finals
 *
 * Revision 1.29  2002/07/04 21:45:03  ritter
 * variation of some finals
 *
 * Revision 1.28  2002/07/04 20:53:34  ritter
 * debugging THE bug
 *
 * Revision 1.27  2002/07/04 16:25:48  stork
 * reactivate log comments 2
 *
 * Revision 1.26  2002/07/04 16:19:13  stork
 * reactivate log comments
 *
 * Revision 1.22  2002/07/04 14:00:47  transier
 * debugging messages
 *
 * Revision 1.21  2002/07/03 20:55:16  transier
 * remove use of NewData, has to be added again
 *
 * Revision 1.20  2002/07/03 18:30:02  transier
 * changed logging
 *
 * Revision 1.19  2002/07/03 16:29:41  transier
 * debug output in logfile, update is called to often!
 *
 * Revision 1.18  2002/07/02 22:30:43  transier
 * debugging
 *
 * Revision 1.17  2002/07/02 15:06:02  transier
 * debugging
 *
 * Revision 1.16  2002/06/24 22:16:04  transier
 * debugging
 *
 * Revision 1.15  2002/06/24 21:31:54  transier
 * debugging
 *
 * Revision 1.14  2002/06/23 12:44:01  transier
 * debugging
 *
 * Revision 1.13  2002/06/21 16:53:42  transier
 * new structure of update function
 *
 * Revision 1.12  2002/06/16 18:40:13  transier
 * some debugging
 *
 * Revision 1.11  2002/06/15 17:31:30  ritter
 * debugging
 *
 * Revision 1.10  2002/06/14 21:43:57  transier
 * some debugging
 *
 * Revision 1.9  2002/06/11 20:24:38  transier
 * some debugging
 *
 * Revision 1.8  2002/06/09 23:29:58  transier
 * some debugging
 *
 * Revision 1.7  2002/06/06 18:15:19  transier
 * new function added:
 *   getGoalShootAngle
 * very first verions of:
 *   dribbleToPoint
 * some changes in update
 * arc to degrees
 *
 * Revision 1.6  2002/06/05 21:17:45  transier
 * new function added:
 *   getPassPartner
 *   getAngleToPoint
 *   gauss
 *
 * Revision 1.5  2002/06/04 20:31:09  transier
 * new function added:
 *   isBetween
 * some changes in update:
 *   the player is now restricted in its field
 *
 * Revision 1.4  2002/06/04 19:26:06  transier
 * new function added
 *   rotateToPoint
 * very first working versions of
 *   catchBall
 *   run
 *   rotate
 *   shout
 * some changes in update
 *
 * Revision 1.3  2002/05/30 20:01:01  transier
 * new function added
 *   calcDist
 * first working versions of
 *   enemiesHaveBall
 *   friendsHaveBall
 *   distanceToBall
 *   HasBall
 * very first working versions of
 *   searchBall
 *
 * Revision 1.2  2002/05/28 13:47:24  ritter
 * first version of rcbrain
 *
 * Revision 1.1.1.1  2002/05/21 20:32:04  stork
 * empty project
 *
 */

import java.util.LinkedList;


/**
 * the basic strategy
 */
public class RCBrain
{
  /** Associations */
  protected RCWorld World;
  protected RCCommunicator Communicator;
  protected double myX, myY;

  protected final double NEAR_BALL = 4.5;	// defines threshold for "the ball is near"
  protected final double MAX_KICK_DIST = .7;	// defines threshold for the range in which player can kick the ball
  protected final double NEAR_BORDER = 2.;	// defines threshold for player is near his boarder
  protected final double NEAR_GOAL = 53.;	// defines threshold for player is near the goal
  protected final double MAX_PASS_DIST = 70.;	// defines threshold for maximum pass distance
  protected final double MIN_PASS_DIST = 4.;	// defines threshold for minimum pass distance
  protected final double BEST_PASS_DIST = 15.;	// defines threshold for best pass distance
  protected final double BARRIER_ANGLE = 2.5;	// defines threshold for angle that has to be added to get the barriers size
  protected final double MIN_LIKELIHOOD_PASS = 0.25;	// defines threshold for minimum pass likelihood
  protected final double MIN_LIKELIHOOD_GOAL = 0.01;	// defines threshold for minimum goal likelihood
  protected final double POWER_COEFF_DASH = 18.;	// defines relation between distance and power for dash command
  protected final double MIN_POWER_DASH = 80;	// defines threshold for the minimum power a dash command is submitted
  protected final double POWER_COEFF_KICK = 120.;	// defines relation between distance and power for kick command
  protected final double MIN_RUN_DIST = 1.5;	// defines minimum distance to make a run
  protected final double HALF_OF_GOALWIDTH = 7.;	// defines the half width of the goal
  protected final double MAX_ANGLE = 7.;	// defines threshold for the maximunm angle differece between the player and his target point
  protected final double SEARCH_ANGLE = 40.;	// defines the angle value for players turn while searching the ball
  protected final double PRECISION = 0.001;
  protected final double GOAL_X = 52.5;
  protected final double GOAL_Y = 0.;
  protected final double KICK_POWER_DIRBBLE = 20.;
  protected final double DASH_POWER_DRIBBLE = 40.;
  protected final double MAX_POWER_KICK = 100.;
  protected final double MIN_OFFSIDE_POS = 35.;
  protected final int MAX_TIME = 10;	// defines threshold in which position information of objects are valid


  /**
   * the gauss function
   *
   * @param value
   * @param median
   * @param deviation 
   */
  protected double gauss (double x, double m, double sigma)
  {

    return Math.exp (-Math.pow (x - m, 2) / Math.pow (sigma, 2));

  }
 
 
  /**
   * calculates the dash power in terms of the run distance
   *
   * @param distance
   */  
  protected double dashPower (double distance)
  {
  
  	double power = POWER_COEFF_DASH * (Math.pow(distance,2)/(distance+1)+1);
  	if (power > MAX_POWER_KICK)
  		power = MAX_POWER_KICK;
  	return power;
  	
  }
  
  
  /**
   * calculates the kick power in terms of the shoot distance
   *
   * @param distance
   */  
  protected double kickPower (double distance)
  {
  	double power = POWER_COEFF_KICK * Math.atan(distance/50.);
  	if (power > MAX_POWER_KICK)
  		power = MAX_POWER_KICK;
  	return power;
  }


  /**
   * calculates the distance between 2 points ("pythagoras")
   *
   * @param x value of point 1
   * @param y value of point 1
   * @param x value of point 2
   * @param y value of point 2
   *
   * @return returns the distance between the two points
   */
  protected double calcDist (double x1, double y1, double x2, double y2)
  {

    double sqrDist = Math.pow (x1 - x2, 2) + Math.pow (y1 - y2, 2);

    return Math.sqrt (sqrDist);

  }


  /**
   * determines if value is between bound1 and bound2
   *
   * @return true if value is between bound1 and bound2 (else: false)
   */
  protected boolean isBetween (double value, double bound1, double bound2)
  {

    if (Math.abs (value - (bound1 + bound2) / 2.) + PRECISION <
	Math.abs ((bound1 - bound2) / 2.))
      return true;
    else
      return false;
  }


  /**
   * calculates the angle between the players direction and a given point
   *
   * @return the angle between the players direction and a given point
   */
  public double getAngleToPoint (double x, double y)
  {

    double X = x - myX;
    double Y = y - myY;

    double angle;
    if (X != 0)
      angle = Math.atan (Math.abs (Y) / Math.abs (X));
    else
      angle = Math.PI / 2.;

    angle = angle * 180. / Math.PI;	// angle in degrees

    if (X < 0 && Y > 0)		// II.
      angle = 180 - angle;
    else if (X < 0 && Y < 0)	// III.
      angle = 180 + angle;
    else if (X >= 0 && Y < 0)	// IV.
      angle = 360 - angle;


    if (World.angle < 0)
      angle -= (360 + World.angle);	// rel. angle
    else
      angle -= World.angle;	// ...

    if (angle < -180)
      angle += 360;
    else if (angle > 180)
      angle -= 360;

    return angle;
  }


  /**
   * determines a pass partner for the player
   *
   * @return a pass partner
   */
  protected RCPartner getPassPartner ()
  {

    int i, k;
    double distance, angle, likelihood, x, y;
    double offsidePos = -GOAL_X, goaliePos = -GOAL_X;
    LinkedList Barriers = new LinkedList ();
    RCPartner Partner = new RCPartner ();
    Partner.likelihood = 0;
    RCPartner Barrier;

    // sort the enemies into a list
    for (i = 0; i < 11; i++)
      {

		x = World.Enemies[i].X (0);
		y = World.Enemies[i].Y (0);

		// where are the two least players? (offside)
		if (x > offsidePos) {
		  if (x > goaliePos)
		    {
		      offsidePos = goaliePos;
		      goaliePos = x;
		    }
		  else
		    offsidePos = x;
		}

		distance = calcDist (myX, myY, x, y);
		if (distance > MAX_PASS_DIST)
		  continue;

		angle = getAngleToPoint (x, y);

		Barriers.add (new RCPartner (World.Enemies[i], angle, distance));

      }
      
    if (offsidePos < MIN_OFFSIDE_POS) {
    	offsidePos = GOAL_X;
    	goaliePos =	GOAL_X;
	}

    for (i = 0; i < 11; i++)
      {

		// myself?
		if (i == (World.PlayerNumber - 1))
		  continue;
		  
		// start value for likelihood
		likelihood = 1;

		// get the position of a possible pass partner
		x = World.Friends[i].X (0);
		y = World.Friends[i].Y (0);

		// friend is offside -> continue
		if (offsidePos < x && myX < offsidePos)
		  continue;

		// calculate the pass distance
		distance = calcDist (x, y, myX, myY);
		if (distance > MAX_PASS_DIST || distance < MIN_PASS_DIST)
		  continue;

		// claculate the angle
		angle = getAngleToPoint (x, y);

		// remove very bad pass partners
		// 1.) friend is near an enemy
		for (k = 0; k < Barriers.size (); k++)
		  {
		    Barrier = (RCPartner) Barriers.get (k);
		    if (distance < Barrier.distance)
		      continue;
		    if (Math.abs (angle - Barrier.angle) > BARRIER_ANGLE)
		      continue;
		    likelihood = 0;
		    break;
		  }
		if (likelihood == 0)
			continue; // partner is bad
		// 2,) friend is near our goal
		if (Math.pow(x+GOAL_X,2)+Math.pow(y,2)<=400) {
			likelihood = 0;
			continue; // partner is bad
		}
		  
		// set likelihood according to the distance
		likelihood = gauss (distance, BEST_PASS_DIST, BEST_PASS_DIST / 2.);

		// the friend which is nearer to goal is preferred
		likelihood = 1./5.*likelihood + 7./15. * (x + 52.5) / 105. + 5./15. * gauss(x,40.,27.) * gauss(y,0.,22.);
		
		// is the likelihood better than the old one? -> we've got a better partner
		if (likelihood > Partner.likelihood)
		  {
		    Partner.angle = angle;
		    Partner.distance = distance;
		    Partner.Player = World.Friends[i];
		    Partner.likelihood = likelihood;
		  }
      }

    return Partner;
  }


  /**
   * try to shoot 
   *
   * @return true if the player has made a shoot
   */
  protected boolean shoot ()
  {

    RCObject me = World.getOurself ();
    myX = me.X (0);
    myY = me.Y (0);

    double ballX = World.Ball.X (0);
    double ballY = World.Ball.Y (0);

    double ballDist = calcDist (myX, myY, ballX, ballY);
    double goalDist = calcDist (myX, myY, GOAL_X, GOAL_Y);

	// is the player able to kick?
    if (ballDist > MAX_KICK_DIST)
      return false;

    if (goalDist <= NEAR_GOAL)
      {
		// player is near the goal -> try a goal shoot		
		double angle = getAngleToPoint(GOAL_X, GOAL_Y);
		double likelihood = 1/goalDist;
		
		if (likelihood > MIN_LIKELIHOOD_GOAL)
		  {		  	
		    Communicator.kick(MAX_POWER_KICK, angle);
		    return true;
		  }
      }

    // try to pass
    RCPartner Partner = getPassPartner ();
    if (Partner.likelihood >= MIN_LIKELIHOOD_PASS)
      {
		Communicator.kick (kickPower(Partner.distance), Partner.angle);
		return true;
      }

    // no shoot was possible
    return false;
  }


  /**
   * dribble to goal
   *
   */
  protected void dribbleToGoal ()
  {

    double ballX = World.Ball.X (0);
    double ballY = World.Ball.Y (0);

    double ballDist = calcDist (myX, myY, ballX, ballY);
    double goalDist = calcDist (myX, myY, GOAL_X, GOAL_Y);

    double goalAngle = getAngleToPoint (GOAL_X, GOAL_Y);
    double ballAngle = getAngleToPoint (ballX, ballY);


    if (ballDist > MAX_KICK_DIST)
      {
		if (Math.abs (ballAngle) >= MAX_ANGLE && !World.NewData)
		    Communicator.turn (ballAngle);
		else
		 	Communicator.dash (dashPower(ballDist));
      }
    else
      {
		 Communicator.kick (KICK_POWER_DIRBBLE, goalAngle);
      }
  }


  /**
   * searches the ball 
   *
   * @return if the position information of the ball is not too old the return value is true
   */
  public boolean searchBall ()
  {

    if (World.Ball.Time (0) + MAX_TIME > World.CurrentTimeStamp)
      return true;
    return false;
  }


  /**
   * determines if the given point is in the players field
   *
   * @return true if the given point is in the players field
   */
  public boolean inField (double x, double y)
  {

    if (isBetween (x, World.X1, World.X2) && isBetween (y, World.Y1, World.Y2))
      return true;
    return false;
  }


  /**
   * every cycle called by the main loop
   *
   * @return 0 if everything is ok
   */
  public int update ()
  {

    RCObject me = World.getOurself ();
    myX = me.X (0);
    myY = me.Y (0);

    double ballX = World.Ball.X (0);
    double ballY = World.Ball.Y (0);

    double ballDist = calcDist (myX, myY, ballX, ballY);
    double goalDist = calcDist (myX, myY, GOAL_X, GOAL_Y);

    if (searchBall ())
      {
		// found ball
		if (ballDist <= NEAR_BALL)
		  {
		    // try to shoot
		    if (!shoot ())
		      {
				// no shoot possible
				dribbleToGoal ();
				return 0;
		      }
		    else
		      return 0;
		  }
		else
		  {
		    // ball is far far away
		    if (inField (myX, myY))
		      {
				// the player is in its field
				if (inField (ballX, ballY))
				  {
				    // and the ball too -> go to ball
				    double angle = getAngleToPoint (ballX, ballY);
				    if (Math.abs (angle) >= MAX_ANGLE && !World.NewData)
				      {
						Communicator.turn (angle);
						return 0;
				      }
				        Communicator.dash (dashPower(ballDist));
				    return 0;
				  }
				else
				  {
				    // ball is not in players field
				    double targetX, targetY;
				    double X = (World.X1 + World.X2) / 2.;	// instead of myX
				    double Y = (World.Y1 + World.Y2) / 2.;	// ...        myY

				    while (true)
				      {

						if (isBetween (World.X1, X, ballX))
						  {
						    // intersection between the border and the ball-player-line
                                                    targetY = (Y - ballY) / (X - ballX) * (World.X1 - ballX) + ballY;
                                                    if (isBetween (targetY, World.Y1, World.Y2))
                                                      {
                                                                targetX = World.X1;
                                                                break;
                                                      }
						  }
						if (isBetween (World.X2, X, ballX))
						  {
						    // intersection between the border and the ball-player-line
						    targetY = (Y - ballY) / (X - ballX) * (World.X2 - ballX) + ballY;
						    if (isBetween (targetY, World.Y1, World.Y2))
						      {
								targetX = World.X2;
								break;
						      }
						  }
						if (isBetween (World.Y1, Y, ballY))
						  {
						    // intersection between the border and the ball-player-line
						    targetX = (X - ballX) / (Y - ballY) * (World.Y1 - ballY) + ballX;
						    if (isBetween (targetX, World.X1, World.X2))
						      {
								targetY = World.Y1;
								break;
						      }
						  }
						if (isBetween (World.Y2, Y, ballY))
						  {
						    // intersection between the border and the ball-player-line
						    targetX = (X - ballX) / (Y - ballY) * (World.Y2 - ballY) + ballX;
						    if (isBetween (targetX, World.X1, World.X2))
						      {
								targetY = World.Y2;
								break;
						      }
						  }
			
						targetX = (World.X1 + World.X2) / 2.;
						targetY = (World.Y1 + World.Y2) / 2.;
						break;
				      }
			
				    double distance = calcDist (myX, myY, targetX, targetY);

				    if (distance > MIN_RUN_DIST)
				      {
						double angle = getAngleToPoint (targetX, targetY);
						if (Math.abs (angle) > MAX_ANGLE && !World.NewData)
						  {
						    Communicator.turn (angle);
						    return 0;
						  }
						double power = dashPower(distance);
						if (power >= MIN_POWER_DASH)
						  {
						    Communicator.dash (power);
						    return 0;
						  }
				      }
				  }
		      }
		    else
		      {
				// player not in its field (and the ball is far far away, as you know) -> go home
				double targetX = (World.X1 + World.X2) / 2.;
				double targetY = (World.Y1 + World.Y2) / 2.;
		
				double angle = getAngleToPoint (targetX, targetY);
				if (Math.abs (angle) >= MAX_ANGLE && !World.NewData)
				  {
				    Communicator.turn (angle);
				    return 0;
				  }
		
				double distance = calcDist (myX, myY, targetX, targetY);
				Communicator.dash (dashPower(distance));
				return 0;
		      }
		  }
      }
    else
      {
      	// ball not found
		if (!inField (myX, myY))
		  {
		    //player not in its field go home
		    double targetX = (World.X1 + World.X2) / 2.;
		    double targetY = (World.Y1 + World.Y2) / 2.;
	
		    double angle = getAngleToPoint (targetX, targetY);
		    if (Math.abs (angle) >= MAX_ANGLE && !World.NewData)
		      {
				Communicator.turn (angle);
				return 0;
		      }

		    double distance = calcDist (myX, myY, targetX, targetY);
		        Communicator.dash (dashPower(distance));
		    return 0;
		  }
		else
		  {
		    // turn to see the ball
		    if (!World.NewData)
		      Communicator.turn (SEARCH_ANGLE);
		    return 0;
		  }
      }

    return 1;
  }


  /**
   * constructor of RCBrain
   *
   * @param World
   * @param Communicator
   */
  public RCBrain (RCWorld World, RCCommunicator Communicator)
  {
    this.World = World;
    this.Communicator = Communicator;
  }
}
