/*
 * $Id: RCDisplay.java,v 1.5 2002/07/09 21:42:32 stork Exp $
 *
 * $Log: RCDisplay.java,v $
 * Revision 1.5  2002/07/09 21:42:32  stork
 * update doukumentation
 *
 * Revision 1.4  2002/07/02 20:53:11  stork
 * add synchronize and resize to improve the display
 *
 * Revision 1.3  2002/06/17 15:33:20  oliver
 * Update of RCDisplay & RCViewport; first step of visualisation:
 * Window popup, own player and lines visible
 *
 * Revision 1.2  2002/06/07 18:13:14  stork
 * extens JFrame
 *
 * Revision 1.1.1.1  2002/05/21 20:32:05  stork
 * empty project
 *
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * the main window
 */
public class RCDisplay extends JFrame {
  /** Attributes */
  public RCWorld World;
  /** Associations */
  private RCViewPort ViewPort;
  /**
   * Operation
   *
   * @param World
   * @return 
   */
  public RCDisplay ( RCWorld World ){
      super("Player "+ World.PlayerNumber);

      // create filed
      ViewPort = new RCViewPort(World);
      Container contentPane = getContentPane();
      contentPane.setLayout(new GridLayout(1,1));
      contentPane.add(ViewPort);

      // set size
      setResizable(false);
      reSize();
      setSize(10,10);
  }

    /**
     * resize window to correct size
     **/
    public void reSize(){
	this.setSize( (int)(this.ViewPort.getSize().width+this.getInsets().left+this.getInsets().right), 
		      (int)(this.ViewPort.getSize().height+this.getInsets().top+this.getInsets().bottom) );
    }


    /**
     * overload paint routine
     *
     * @param g graphic device
     */
    public synchronized void paint( Graphics g ){
	super.paint(g);
	reSize();
    }


  /**
   * Operation
   *
   */
  public synchronized void update (  ){
      this.repaint();
      ViewPort.repaint();
  }
}

