/*
 * $Id: RCObject.java,v 1.4 2002/06/27 20:26:39 stork Exp $
 *
 * $Log: RCObject.java,v $
 * Revision 1.4  2002/06/27 20:26:39  stork
 * add + update dokumentation
 *
 * Revision 1.3  2002/06/08 14:40:02  stork
 * exception error fixed
 *
 * Revision 1.2  2002/05/29 15:17:48  stork
 * implement object
 *
 * Revision 1.1.1.1  2002/05/21 20:32:05  stork
 * empty project
 *
 */
import java.util.*;


/**
 * This class is the representation of all movable objects on the field.
 */
public class RCObject {
  /** Attributes */
    public LinkedList XList;
    public LinkedList YList;
    public LinkedList TimeList;
    public int HistoryLength;

    /**
     * Construktor.
     */
    public RCObject(){
	/* init */
	XList = new LinkedList();
	YList = new LinkedList();
	TimeList = new LinkedList();

	HistoryLength = 3;
    }


    /**
    * access to X-Value history
    *
    * @param History
    * @return double
    */
    public double X ( int History ){
	double retVal = 0;
	try{
	    retVal = ((Double)(XList.get(History))).doubleValue();
	}catch(Exception e){
	    retVal = 0;
	}
	return retVal;
    }

    /**
     * access to X-Value history
     *
     * @param History 
     * @return double y-value to History 
     */
    public double Y ( int History ){
	double retVal = 0;
	try{
	    retVal = ((Double)(YList.get(History))).doubleValue();
	}catch(Exception e){
	    retVal = 0;
	}
	return retVal;
    }

    /**
     * access to TimeValue history
     *
     * @param History 
     * @return int timestamp to history value
     */
    public int Time ( int History ){
	int retVal = 0;
	try{
	    retVal = ((Integer)(TimeList.get(History))).intValue();
	}catch(Exception e){
	    retVal = 0;
	}
	return retVal;
    }

    /**
     * add a value to history 
     *
     * @param Value the value to insert
     */
    public void insertX ( double Value ){
	XList.addFirst(new Double(Value));
	if( XList.size() > HistoryLength )
	    XList.removeLast();
    }

    /**
     * add a value to history
     *
     * @param Value the value to insert
     */
    public void insertY ( double Value ){
	YList.addFirst(new Double(Value));
	if( YList.size() > HistoryLength )
	    YList.removeLast();
    }

    /**
     * add a timestamp value to history
     *
     * @param Time value to insert in history
     */
    public void insertTime ( int Time ){
	TimeList.addFirst(new Integer(Time));
	if( TimeList.size() > HistoryLength )
	    TimeList.removeLast();
    }
}

