/*
 * $Id: RCTeam.java,v 1.19 2002/07/09 21:42:32 stork Exp $
 *
 * $Log: RCTeam.java,v $
 * Revision 1.19  2002/07/09 21:42:32  stork
 * update doukumentation
 *
 * Revision 1.18  2002/07/05 18:34:08  stork
 * update dokumentation
 *
 * Revision 1.17  2002/07/03 17:24:03  stork
 * add log to shell
 *
 * Revision 1.16  2002/07/02 20:56:19  stork
 * add support for central Log
 *
 * Revision 1.15  2002/06/27 20:26:40  stork
 * add + update dokumentation
 *
 * Revision 1.14  2002/06/22 20:15:41  stork
 * add some more dokumentation
 *
 * Revision 1.13  2002/06/21 17:35:32  stork
 * little fix
 *
 * Revision 1.12  2002/06/16 17:46:21  stork
 * rounding double to 3 digits after the comma
 *
 * Revision 1.11  2002/06/10 20:51:02  stork
 * add enemies to info command
 *
 * Revision 1.10  2002/06/08 14:41:13  stork
 * add info to shell
 *
 * Revision 1.9  2002/06/07 21:41:28  stork
 * modify the shell:
 * - remove quad. from config
 *
 * Revision 1.8  2002/06/07 18:15:15  stork
 * add send support for shell
 *
 * Revision 1.5  2002/05/30 15:37:16  stork
 * improve handling when server dies before we
 *
 * Revision 1.4  2002/05/29 21:07:19  stork
 * new config file syntax
 *
 * Revision 1.3  2002/05/25 22:03:56  stork
 * add config file support
 *
 * Revision 1.2  2002/05/21 20:57:14  stork
 * first communicator version
 *
 * Revision 1.1.1.1  2002/05/21 20:32:05  stork
 * empty project
 *
 */
import java.io.*;
import java.util.*;

/**
 * The main class. It reads the configfile and create a new team with the
 * that configguration. After the team was created it starts the shell.
 */
public class RCTeam {
    /** Attributes */
    public static RCPlayer[] Players;

    /**
     * convert double to a double with Digits numbers after the comma
     *
     * @param Value input value
     * @param Digits number of digits
     * @return convertet value
     */
    public static double doubleRound( double Value, int Digits ){
	return (((double)((int)(Value*Math.pow(10,Math.abs(Digits)))))/(1.0*Math.pow(10,Math.abs(Digits))));
    }

    /**
     * programm entry.
     *
     * @param args[] parameters
     */
    static public void main ( String args[] ){
	String TeamName = "";
	String Server = "localhost";
	int Port = 6000;
	int PlayerCount = 0 ; // number of players we create

	// parse arguments
	if( (args.length == 0) || (args.length > 3) ){
	    /* wrong arguments */
	    System.out.println("usage: java RCTeam \"TEAMNAME\" [SERVER] [PORT] ");
	    System.exit(1);
	}else{
	    /* parse arguments */
	    try{
		TeamName = args[0];
		if( args.length >= 2 )
		    Server = args[1];
		if ( args.length == 3 )
		    Port = Integer.parseInt(args[2], 10);
	    }catch(NumberFormatException e){
		System.out.println(e);
		System.exit(1);
	    }
	}

	// create players
	Players = new RCPlayer[11];
	// create log
	RCLog Log = new RCLog();
	try{
	    /* open log file */
	    BufferedReader Config = new BufferedReader(new FileReader("RCTeam.cfg"));;
	    String Line ;
	    /* read & parse config file */
	    while( ((Line=Config.readLine()) != null) && (PlayerCount < 11) ){
		Line = Line.trim();
		if( Line.startsWith("#") == false ){
		    StringTokenizer tk = new StringTokenizer(Line, ":");
		    if( tk.countTokens() == 6){
			try{
			    boolean Goalie = Boolean.valueOf(tk.nextToken()).booleanValue();
			    boolean Visual = Boolean.valueOf(tk.nextToken()).booleanValue();

			    /* create a new player */
			    Players[PlayerCount] = new RCPlayer(TeamName, 
								Visual,
								Server,
								Port,
								Goalie, 
								Float.valueOf(tk.nextToken()).floatValue(),
								Float.valueOf(tk.nextToken()).floatValue(),
								Float.valueOf(tk.nextToken()).floatValue(),
								Float.valueOf(tk.nextToken()).floatValue(),
								Log);
			    /* start the player */
			    //Players[PlayerCount].setPriority(Thread.MAX_PRIORITY);
			    Players[PlayerCount].start();
			    /* update internal state */
			    PlayerCount++;
			}catch(Exception e){
			    System.out.println(e.toString());
			    System.exit(1);
			}
		    }
		}
	    }	 
	}catch(IOException e){
	    // shit happens
	    System.out.println(e.toString());
	    System.exit(1);
	}
     
     
	// open shell 
	final String Prompt = "[rcteam]> ";
	boolean doShell = true;
	BufferedReader Input = new BufferedReader(new InputStreamReader(System.in));

	/* display prolog */
	System.out.println("RCTeam Shell");
	System.out.println("use h <ENTER> for help");
	/* enter input loop */
	while( doShell ){
	    try{
		String Command;
		System.out.print(Prompt);
		StringTokenizer Line= new StringTokenizer(Input.readLine().trim());

		/* wrong input ? */
		if( Line.hasMoreTokens())
		    Command = Line.nextToken().trim();
		else
		    Command = "help";

		/* try to satisfy the user */
		if( (Command.compareTo("quit") == 0) || (Command.compareTo("q") == 0) ){
		    // we are finish
		    doShell = false;
		}else if((Command.compareTo("log") == 0) || (Command.compareTo("l") == 0) ){
		    if( Line.hasMoreTokens() ){
			try{
			    Log.activeLog = (Boolean.valueOf(Line.nextToken())).booleanValue();
			}catch(Exception e){
			    System.out.println("log "+e.toString());
			}
		    }
		    // output the current status
		    if( Log.activeLog ==  true )
			System.out.println("Logging enabled");
		    else
			System.out.println("Logging disabled");
		    
		}else if( (Command.compareTo("info") == 0) || (Command.compareTo("i") == 0)){
		    if( Line.hasMoreTokens() ){
			try{
			    int PlayerNumber = Math.abs(Integer.parseInt(Line.nextToken()));
			    
			    if( (PlayerNumber > 0) && (PlayerNumber <= PlayerCount)){
				System.out.println("Player's Number   = " + PlayerNumber);
				System.out.println("Player's Time     = " + Players[PlayerNumber-1].World.CurrentTimeStamp);
				System.out.println("Player's Angle    = " + Players[PlayerNumber-1].World.angle);
				System.out.println("Player'a Position = ("+RCTeam.doubleRound((Players[PlayerNumber-1].World.getOurself().X(0)),3)+", "+RCTeam.doubleRound((Players[PlayerNumber-1].World.getOurself().Y(0)),3)+")");
 				System.out.println("Player's Ball     = (" + RCTeam.doubleRound(Players[PlayerNumber-1].World.Ball.X(0),3)+"/"+RCTeam.doubleRound(Players[PlayerNumber-1].World.Ball.Y(0),3)+") at "+ Players[PlayerNumber-1].World.Ball.Time(0) );
 				System.out.println("Player's Area     = ("+
 						   RCTeam.doubleRound(Players[PlayerNumber-1].World.X1,3)+", "+RCTeam.doubleRound(Players[PlayerNumber-1].World.Y1,3)+") => ("+
 						   RCTeam.doubleRound(Players[PlayerNumber-1].World.X2,3)+", "+RCTeam.doubleRound(Players[PlayerNumber-1].World.Y2,3)+")");
				for(int x = 0; x < 11 ; x++){
				    System.out.println("Player's Enemy "+x+" : ("+
						       RCTeam.doubleRound(Players[PlayerNumber-1].World.Enemies[x].X(0),3)+", "+
						       RCTeam.doubleRound(Players[PlayerNumber-1].World.Enemies[x].Y(0),3)+") at "+
						       Players[PlayerNumber-1].World.Enemies[x].Time(0));
				}
			    }
			}catch(Exception e){
			    System.out.println("parse error");
			}
		    }
		}else if( (Command.compareTo("network") == 0) || (Command.compareTo("n") == 0)){
		    // show information of connection
		    System.out.println("Server : " + Server );
		    System.out.println("Port   : " + Port);
		}else if( (Command.compareTo("display")==0) || (Command.compareTo("d")==0)){
		    if( Line.hasMoreTokens()){
			try{
			    int number = Math.abs(Integer.parseInt(Line.nextToken()));
			    if( (number <= PlayerCount) && (number > 0) ){
				Players[number-1].setVisible(true);
			    }
			}catch(Exception e){
			    
			}
		    }
		}else if( (Command.compareTo("config")==0) || (Command.compareTo("c")==0) ){
		    System.out.println("Number of Players  : " + PlayerCount );
		    System.out.println("Number\tGoalie\tVisual\tStartPoint\tCurrentPoint");
		    System.out.println("================================================================================");
		    for(int c = 0 ; c < PlayerCount ; c++){
			System.out.println((c+1)+
					   "\t"+Players[c].Communicator.Goalie+
					   "\t"+Players[c].isVisible()+
					   "\t("+RCTeam.doubleRound(((Players[c].World.X1+Players[c].World.X2)/2),3)+", "+RCTeam.doubleRound(((Players[c].World.Y1+Players[c].World.Y2)/2), 3)+")"+
					   "\t("+RCTeam.doubleRound((Players[c].World.getOurself().X(0)),3)+", "+RCTeam.doubleRound((Players[c].World.getOurself().Y(0)),3)+")");
			    //					   "\t("+Players[c].World.X1+", "+Players[c].World.Y1+") => ("+Players[c].World.X2+", "+Players[c].World.Y2+")");
		    }
		}else if( (Command.compareTo("send") == 0) || (Command.compareTo("s") == 0)){
		    if( Line.hasMoreTokens() ){		   
			try{
			    int PlayerNumber = Math.abs(Integer.parseInt(Line.nextToken()));
			    // send the message
			    
			    if( (PlayerNumber > 0) && 
				(PlayerNumber <= PlayerCount) && 
				(Line.hasMoreTokens())){
				String Message = "";
				//while( Line.hasMoreTokens() )
				//    Message = Message + Line.nextToken()+ " ";
				Message = Line.nextToken("\n").trim();
				System.out.println("< "+Message);
				Players[PlayerNumber-1].Communicator.send(Message);
			    }

			}catch(Exception e){
			    
			}
		    }		    
		}else{		    
		    // print help message
		    System.out.println("(c)onfig        - print configuration of the team");
		    System.out.println("(d)isplay NUM   - activate display for the specified player");
		    System.out.println("(i)nfo NUM      - dump information for current player");
		    System.out.println("(h)elp          - print this message");
		    System.out.println("(l)og BOOL      - 1=enable, 0=disable");
		    System.out.println("(n)network      - show connection info");
		    System.out.println("(q)uit          - quit the team with all the players");		   
		    System.out.println("(s)end NUM MSG  - send MSG for player NUM");
		}	 	  
	    }catch(IOException e){
		System.out.println(e.toString());
		doShell = false;

	    }
	}

	// kill all players
 	for( int x=0 ; x < PlayerCount ; x++ )
 	    Players[x].interrupt();

	// just for fun
	System.out.print("A Strange Game .\n");
	System.out.println("The only winning move is not to play.");
	
	// we are finish
	System.exit(0);
    }
}
